//+------------------------------------------------------------------+
//|                                               zigzag-pointer.mq4 |
//|                                    zigzag modified by Dr. Gaines |
//|                                      dr_richard_gaines@yahoo.com |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "dr_richard_gaines"
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
//---- indicator parameters
extern int ExtDepth=105;//105;//21;
extern int ExtDeviation=120;//120;//24;
extern int ExtBackstep=70;//70;//14;

extern bool Alert1Signal      = false;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;
extern bool alertsNotific   = true;

extern string    AlertSoundB                      = "Buy.wav";
extern string    AlertSoundS                      = "Sell.wav";
//---- indicator buffers
double ZigZagUp[];
double ZigZagDown[];
datetime Time0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1, 234);
//---- indicator buffers mapping
   SetIndexBuffer(0,ZigZagUp);
   SetIndexBuffer(1,ZigZagDown);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);     
//---- indicator short name
   IndicatorShortName("ZigZag("+ExtDepth+","+ExtDeviation+","+ExtBackstep+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,limit1,limit2;
   int counted_bars = IndicatorCounted();
   limit1=1200-counted_bars;
   if ( i> limit2) 
   limit2= i;    
   if (limit2 <1200- 1)
   limit1 =1200- 1; 
   
   
   int    shift, back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;

   for(shift=Bars-ExtDepth; shift>=0; shift--)
     {
      val=Low[Lowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ZigZagUp[shift+back];
               if((res!=0)&&(res>val)) { ZigZagUp[shift+back]=0.0; } 
              }
           }
        } 
      ZigZagUp[shift]=val;
      //--- high
      val=High[Highest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*Point)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ZigZagDown[shift+back];
               if((res!=0)&&(res<val)){ ZigZagDown[shift+back]=0.0; } 
              } 
           }
        }
      ZigZagDown[shift]=val;
     }

   // final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(shift=Bars-ExtDepth; shift>=0; shift--)
     {
      curlow=ZigZagUp[shift];
      curhigh=ZigZagDown[shift];
      if((curlow==0)&&(curhigh==0)) continue;
      //---
      if(curhigh!=0)
        {
         if(lasthigh>0) 
           {
            if(lasthigh<curhigh)
             {
              ZigZagDown[lasthighpos]=0;
             }
            else ZigZagDown[shift]=0;
           }
         //---
         if(lasthigh<curhigh || lasthigh<0)
           {
            lasthigh=curhigh;
            lasthighpos=shift;
           }
         lastlow=-1;
        }
      //----
      if(curlow!=0)
        {
         if(lastlow>0)
           {
            if(lastlow>curlow)
             {
              ZigZagUp[lastlowpos]=0;
            }
            else ZigZagUp[shift]=0;
           }
         //---
         if((curlow<lastlow)||(lastlow<0))
           {
            lastlow=curlow;
            lastlowpos=shift;
           } 
         lasthigh=-1;
        }
     }
  
   for(shift=Bars-1; shift>=0; shift--)
     {
      if(shift>=Bars-ExtDepth) ZigZagUp[shift]=0.0;
      else
        {
         res=ZigZagDown[shift];
         if(res!=0.0) ZigZagDown[shift]=res;
        }
     }
     
  if  (Alert1Signal )
      { 
   int  hh = TimeHour ( TimeCurrent ());
   int  mm = TimeMinute ( TimeCurrent ());          
if(ZigZagUp[1]!=0&&Time0!=Time[0])
{
       if (alertsMessage) Alert("Ultimate ARROW"+" UP "+" "+Symbol(),"",Period()+" "+ hh +":"+ mm+"");
       if (alertsSound) {PlaySound(AlertSoundB);} else if (!alertsSound) PlaySound("birdMy.wav");
       if (alertsEmail) SendMail("Ultimate ARROW"," UP "+Symbol()+"["+Period()+"]"+""+ hh +":"+ mm+"");
       if (alertsNotific)SendNotification("Ultimate ARROW"+" UP " + _Symbol + "["+_Period +"]"+ hh +":"+ mm+"");
 Time0=Time[0];
}
if(ZigZagDown[1]!=0&&Time0!=Time[0])
{
       if (alertsMessage)  Alert("Ultimate ARROW"+" DOWN "+" "+Symbol(),"",Period()+" "+ hh +":"+ mm+"");
       if (alertsSound) {PlaySound(AlertSoundS);} else if (!alertsSound) PlaySound("birdMy.wav");
       if (alertsEmail) SendMail("Ultimate ARROW"," DOWN "+Symbol()+"["+Period()+"]"+""+ hh +":"+ mm+"");
       if (alertsNotific)SendNotification("Ultimate ARROW"+" DOWN " + _Symbol + "["+_Period +"]"+""+ hh +":"+ mm+""); 
 Time0=Time[0];
}
}
////////////////////////////////////////////////

  for( i=limit1;i>=0;i--)
     { 
         if(ZigZagUp[i]!=0 )
           {
            DrawArULTIMATE("upULTIMATE",i);  
                    
           }
          
         if(ZigZagDown[i]!=0 )
           {
            DrawArULTIMATE("dnULTIMATE",i); 
            
           }
}



   if (i> limit2) 
   limit2= i; 
   return(0);
  }
  
  //end//
  
  void DrawArULTIMATE(string ssName, int i)
{
    
    string sName=" ULTIMATE "+ssName+" "+ TimeToStr(Time[i],TIME_DATE|TIME_MINUTES);
    ObjectDelete(sName);    
    ObjectCreate(sName, OBJ_ARROW, 0, Time[i], 0);
    double gap =iATR(Symbol(),0,100,i)/2;
    if(ssName=="upULTIMATE")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  158);
    ObjectSet(sName, OBJPROP_PRICE1, Low[i]- 3*gap);
    ObjectSet(sName, OBJPROP_COLOR, Blue);
    }
    if(ssName=="dnULTIMATE")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  158);
    ObjectSet(sName, OBJPROP_PRICE1, High[i]+3*gap);
    ObjectSet(sName, OBJPROP_COLOR, Red);    
    }    
    ObjectSet(sName, OBJPROP_WIDTH, 3);
} 